From a832e3c459797c2ebfc8cda8b8143d4a962c39d0 Mon Sep 17 00:00:00 2001
From: Viktor Ashirov <vashirov@redhat.com>
Date: Fri, 11 Mar 2016 16:53:06 +0100
Subject: [PATCH] Change default ports for standalone topology

Bug description:
Some ports defined in _constants.py are invalid, because they're bigger
than 65535.

Fix description:
Change default ports for standalone topology with a range of ports
38930-38969.
---
 lib389/_constants.py | 80 ++++++++++++++++++++++++++--------------------------
 1 file changed, 40 insertions(+), 40 deletions(-)

diff --git a/lib389/_constants.py b/lib389/_constants.py
index 5fdbe7b..e2c835f 100644
--- a/lib389/_constants.py
+++ b/lib389/_constants.py
@@ -231,184 +231,184 @@ PASSWORD = 'password'
 
 # Standalone topology - 10 instances
 HOST_STANDALONE = LOCALHOST
-PORT_STANDALONE = 31389
+PORT_STANDALONE = 38931
 SERVERID_STANDALONE = 'standalone'
 
 HOST_STANDALONE2 = LOCALHOST
-PORT_STANDALONE2 = 32389
+PORT_STANDALONE2 = 38932
 SERVERID_STANDALONE2 = 'standalone_2'
 
 HOST_STANDALONE3 = LOCALHOST
-PORT_STANDALONE3 = 33389
+PORT_STANDALONE3 = 38933
 SERVERID_STANDALONE3 = 'standalone_3'
 
 HOST_STANDALONE4 = LOCALHOST
-PORT_STANDALONE4 = 34389
+PORT_STANDALONE4 = 38934
 SERVERID_STANDALONE4 = 'standalone_4'
 
 HOST_STANDALONE5 = LOCALHOST
-PORT_STANDALONE5 = 35389
+PORT_STANDALONE5 = 38935
 SERVERID_STANDALONE5 = 'standalone_5'
 
 HOST_STANDALONE6 = LOCALHOST
-PORT_STANDALONE6 = 36389
+PORT_STANDALONE6 = 38936
 SERVERID_STANDALONE6 = 'standalone_6'
 
 HOST_STANDALONE7 = LOCALHOST
-PORT_STANDALONE7 = 37389
+PORT_STANDALONE7 = 38937
 SERVERID_STANDALONE7 = 'standalone_7'
 
 HOST_STANDALONE8 = LOCALHOST
-PORT_STANDALONE8 = 38389
+PORT_STANDALONE8 = 38939
 SERVERID_STANDALONE8 = 'standalone_8'
 
 HOST_STANDALONE9 = LOCALHOST
-PORT_STANDALONE9 = 39389
+PORT_STANDALONE9 = 38939
 SERVERID_STANDALONE9 = 'standalone_9'
 
 HOST_STANDALONE10 = LOCALHOST
-PORT_STANDALONE10 = 30389
+PORT_STANDALONE10 = 38930
 SERVERID_STANDALONE10 = 'standalone_10'
 
 # Replication topology: 10 masters, 10 hubs, 10 consumers
 HOST_MASTER_1 = LOCALHOST
-PORT_MASTER_1 = 41389
+PORT_MASTER_1 = 38941
 SERVERID_MASTER_1 = 'master_1'
 REPLICAID_MASTER_1 = 1
 
 HOST_MASTER_2 = LOCALHOST
-PORT_MASTER_2 = 42389
+PORT_MASTER_2 = 38942
 SERVERID_MASTER_2 = 'master_2'
 REPLICAID_MASTER_2 = 2
 
 HOST_MASTER_3 = LOCALHOST
-PORT_MASTER_3 = 43389
+PORT_MASTER_3 = 38943
 SERVERID_MASTER_3 = 'master_3'
 REPLICAID_MASTER_3 = 3
 
 HOST_MASTER_4 = LOCALHOST
-PORT_MASTER_4 = 44389
+PORT_MASTER_4 = 38944
 SERVERID_MASTER_4 = 'master_4'
 REPLICAID_MASTER_4 = 4
 
 HOST_MASTER_5 = LOCALHOST
-PORT_MASTER_5 = 45389
+PORT_MASTER_5 = 38945
 SERVERID_MASTER_5 = 'master_5'
 REPLICAID_MASTER_5 = 5
 
 HOST_MASTER_6 = LOCALHOST
-PORT_MASTER_6 = 46389
+PORT_MASTER_6 = 38946
 SERVERID_MASTER_6 = 'master_6'
 REPLICAID_MASTER_6 = 6
 
 HOST_MASTER_7 = LOCALHOST
-PORT_MASTER_7 = 47389
+PORT_MASTER_7 = 38947
 SERVERID_MASTER_7 = 'master_7'
 REPLICAID_MASTER_7 = 7
 
 HOST_MASTER_8 = LOCALHOST
-PORT_MASTER_8 = 48389
+PORT_MASTER_8 = 38948
 SERVERID_MASTER_8 = 'master_8'
 REPLICAID_MASTER_8 = 8
 
 HOST_MASTER_9 = LOCALHOST
-PORT_MASTER_9 = 49389
+PORT_MASTER_9 = 38949
 SERVERID_MASTER_9 = 'master_9'
 REPLICAID_MASTER_9 = 9
 
 HOST_MASTER_10 = LOCALHOST
-PORT_MASTER_10 = 40389
+PORT_MASTER_10 = 38940
 SERVERID_MASTER_10 = 'master_10'
 REPLICAID_MASTER_10 = 10
 
 HOST_HUB_1 = LOCALHOST
-PORT_HUB_1 = 51389
+PORT_HUB_1 = 38951
 SERVERID_HUB_1 = 'hub_1'
 REPLICAID_HUB_1 = 65535
 
 HOST_HUB_2 = LOCALHOST
-PORT_HUB_2 = 52389
+PORT_HUB_2 = 38952
 SERVERID_HUB_2 = 'hub_2'
 REPLICAID_HUB_2 = 65535
 
 HOST_HUB_3 = LOCALHOST
-PORT_HUB_3 = 53389
+PORT_HUB_3 = 38953
 SERVERID_HUB_3 = 'hub_3'
 REPLICAID_HUB_3 = 65535
 
 HOST_HUB_4 = LOCALHOST
-PORT_HUB_4 = 54389
+PORT_HUB_4 = 38954
 SERVERID_HUB_4 = 'hub_4'
 REPLICAID_HUB_4 = 65535
 
 HOST_HUB_5 = LOCALHOST
-PORT_HUB_5 = 55389
+PORT_HUB_5 = 38955
 SERVERID_HUB_5 = 'hub_5'
 REPLICAID_HUB_5 = 65535
 
 HOST_HUB_6 = LOCALHOST
-PORT_HUB_6 = 56389
+PORT_HUB_6 = 38956
 SERVERID_HUB_6 = 'hub_6'
 REPLICAID_HUB_6 = 65535
 
 HOST_HUB_7 = LOCALHOST
-PORT_HUB_7 = 57389
+PORT_HUB_7 = 38957
 SERVERID_HUB_7 = 'hub_7'
 REPLICAID_HUB_7 = 65535
 
 HOST_HUB_8 = LOCALHOST
-PORT_HUB_8 = 58389
+PORT_HUB_8 = 38958
 SERVERID_HUB_8 = 'hub_8'
 REPLICAID_HUB_8 = 65535
 
 HOST_HUB_9 = LOCALHOST
-PORT_HUB_9 = 59389
+PORT_HUB_9 = 38959
 SERVERID_HUB_9 = 'hub_9'
 REPLICAID_HUB_9 = 65535
 
 HOST_HUB_10 = LOCALHOST
-PORT_HUB_10 = 50389
+PORT_HUB_10 = 38950
 SERVERID_HUB_10 = 'hub_10'
 REPLICAID_HUB_10 = 65535
 
 HOST_CONSUMER_1 = LOCALHOST
-PORT_CONSUMER_1 = 61389
+PORT_CONSUMER_1 = 38961
 SERVERID_CONSUMER_1 = 'consumer_1'
 
 HOST_CONSUMER_2 = LOCALHOST
-PORT_CONSUMER_2 = 62389
+PORT_CONSUMER_2 = 38962
 SERVERID_CONSUMER_2 = 'consumer_2'
 
 HOST_CONSUMER_3 = LOCALHOST
-PORT_CONSUMER_3 = 63389
+PORT_CONSUMER_3 = 38963
 SERVERID_CONSUMER_3 = 'consumer_3'
 
 HOST_CONSUMER_4 = LOCALHOST
-PORT_CONSUMER_4 = 64389
+PORT_CONSUMER_4 = 38964
 SERVERID_CONSUMER_4 = 'consumer_4'
 
 HOST_CONSUMER_5 = LOCALHOST
-PORT_CONSUMER_5 = 65389
+PORT_CONSUMER_5 = 38965
 SERVERID_CONSUMER_5 = 'consumer_5'
 
 HOST_CONSUMER_6 = LOCALHOST
-PORT_CONSUMER_6 = 66389
+PORT_CONSUMER_6 = 38966
 SERVERID_CONSUMER_6 = 'consumer_6'
 
 HOST_CONSUMER_7 = LOCALHOST
-PORT_CONSUMER_7 = 67389
+PORT_CONSUMER_7 = 38967
 SERVERID_CONSUMER_7 = 'consumer_7'
 
 HOST_CONSUMER_8 = LOCALHOST
-PORT_CONSUMER_8 = 68389
+PORT_CONSUMER_8 = 38968
 SERVERID_CONSUMER_8 = 'consumer_8'
 
 HOST_CONSUMER_9 = LOCALHOST
-PORT_CONSUMER_9 = 69389
+PORT_CONSUMER_9 = 38969
 SERVERID_CONSUMER_9 = 'consumer_9'
 
 HOST_CONSUMER_10 = LOCALHOST
-PORT_CONSUMER_10 = 60389
+PORT_CONSUMER_10 = 38960
 SERVERID_CONSUMER_10 = 'consumer_10'
 
 # Each defined instance above must be added in that list
-- 
2.7.0